/* 
 * Vertex shader for orthogonal projection. 
 * xorc1zt
 * 2012
 *
 * About x64: Vertex must be 4 bytes Integer (INT32).
 *
*/

#version 330

in ivec3 in_Vertex3Di;
in vec3 in_Vertex3Df;
in vec2 in_TexCoord0;

uniform bool integer = false;
uniform mat4 projection;

out vec2 texCoord0;

void main() 
{   
    vec4 vertex;
    
    if( integer ) {
        vertex = vec4( in_Vertex3Di, 1 );
    } else {
        vertex = vec4( in_Vertex3Df, 1 );
    }
        
    gl_Position = projection * vertex;
    texCoord0   = in_TexCoord0;
}